//////////////////////////////////////////////////////////////////////
// sangoma_port_configurator.h: interface for the sangoma_port_configurator class.
//
// Author	:	David Rokhvarg	<davidr@sangoma.com>
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SANGOMA_PORT_CONFIGURATOR_H__6096CC80_8F41_4AAB_9635_6B4C75B6A792__INCLUDED_)
#define AFX_SANGOMA_PORT_CONFIGURATOR_H__6096CC80_8F41_4AAB_9635_6B4C75B6A792__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "sangoma_port.h"

#define MAX_COMP_INSTID 2096
#define MAX_COMP_DESC   2096
#define MAX_FRIENDLY    2096	
#define TMP_BUFFER_LEN	200

class sangoma_port_configurator : public sangoma_port
{

	TCHAR	name[MAX_FRIENDLY];
	char    szCompInstanceId[MAX_COMP_INSTID];
	TCHAR   szCompDescription[MAX_COMP_DESC];
	TCHAR   szFriendlyName[MAX_FRIENDLY];
	DWORD   dwRegType;

	HKEY	hPortRegistryKey;

	port_cfg_t	port_cfg;

	int DoPortConfigurationCommand(port_cfg_t *port_cfg);

	//GET current configuraion of the API driver
	int DoGetDriverConfigurationCommand(port_cfg_t *port_cfg);

	//SET new configuration of the API driver
	int SetPortVolatileConfigurationCommand(port_cfg_t *port_cfg);

	int set_volatile_configration(port_cfg_t *port_cfg);
	int set_registry_configration(port_cfg_t *port_cfg);

public:
	sangoma_port_configurator();
	virtual ~sangoma_port_configurator();
	
	int open_port_registry_key(hardware_info_t *hardware_info);

	int get_configration(port_cfg_t *port_cfg);
	int set_default_configuration(port_cfg_t *port_cfg);

	//Function to check correctness of 'port_cfg_t' structure.
	int check_port_cfg_structure(port_cfg_t *port_cfg);

	//Function to print contents of 'port_cfg_t' structure.
	int print_port_cfg_structure(port_cfg_t *port_cfg);

	//Function to print contents of 'sdla_fe_cfg_t' structure.
	int print_sdla_fe_cfg_t_structure(sdla_fe_cfg_t *sdla_fe_cfg);

	//Function to print contents of 'wanif_conf_t' structure.
	int print_wanif_conf_t_structure(wanif_conf_t *wanif_conf);
};

#endif // !defined(AFX_SANGOMA_PORT_CONFIGURATOR_H__6096CC80_8F41_4AAB_9635_6B4C75B6A792__INCLUDED_)
